import itertools
import math


def euclidean_distance(point1, point2):
    return math.sqrt((point1[0] - point2[0]) ** 2 + (point1[1] - point2[1]) ** 2)


def total_distance(points, order):
    return sum(euclidean_distance(points[order[i]], points[order[i + 1]]) for i in range(len(order) - 1))


def shortest_path(points):
    n = len(points)
    min_distance = float('inf')
    best_order = None

    for order in itertools.permutations(range(n)):
        current_distance = total_distance(points, order)
        if current_distance < min_distance:
            min_distance = current_distance
            best_order = order

    return min_distance



if __name__ == "__main__":
    n = int(input())
    points = []

    for _ in range(n):
        x, y = map(float, input().split())
        points.append((x, y))

    shortest_distance = shortest_path(points)
    print(f"{shortest_distance:.12f}")